package com.framsticks.communication.util;

import com.framsticks.communication.StateCallback;
import com.framsticks.util.FramsticksException;

import org.apache.log4j.Logger;

/**
 * @author Piotr Sniegowski
 */
public class LoggingStateCallback<C> extends StateCallback<C> {

	protected final Logger logger;
	protected final String message;

	public LoggingStateCallback(Logger logger, String message) {
		this.logger = logger;
		this.message = message;
	}

	@Override
	public void handle(FramsticksException e) {
		logger.error("failed to " + message + " with " + e);
	}

	@Override
	public void callImpl() {
		logger.debug(message);
	}
}
