package com.framsticks.util;

import com.framsticks.util.dispatching.ExceptionResultHandler;

public abstract class AbstractStateFunctor implements StateFunctor {

	protected final ExceptionResultHandler handler;

	public AbstractStateFunctor() {
		this.handler = null;
	}

	public AbstractStateFunctor(ExceptionResultHandler handler) {
		this.handler = handler;
	}

	@Override
	public void handle(FramsticksException exception) {
		if (handler != null) {
			handler.handle(exception);
			return;
		}
		throw exception;
	}

}
