package com.framsticks.util;

import org.apache.log4j.Logger;

import com.framsticks.util.dispatching.ExceptionResultHandler;

/**
 * @author Piotr Sniegowski
 */
public abstract class Logging {
	public static boolean log(Logger logger, String action, Object subject, Exception e) {
		if (e != null) {
			logger.error("failed to " + action + " " + subject + ": ", e);
			return true;
		}
		if (logger.isDebugEnabled()) {
			logger.debug("done: " + action + " " + subject);
		}
		return false;
	}

	public static ExceptionResultHandler logger(final Logger logger, final String action, final Object subject) {
		return new ExceptionResultHandler() {
			@Override
			public void handle(FramsticksException e) {
				Logging.log(logger, action, subject, e);
			}
		};
	}
}
