package com.framsticks.util;

import com.framsticks.util.dispatching.Dispatcher;
import com.framsticks.util.dispatching.Task;
import com.framsticks.util.dispatching.RunAt;

/**
 * @author Piotr Sniegowski
 */
public abstract class PeriodicTask<C> extends RunAt<C> {

	protected final long period;
	protected Dispatcher<? super C> dispatcher;

	public PeriodicTask(Dispatcher<? super C> dispatcher, long period) {
		this.period = period;
		this.dispatcher = dispatcher;
		dispatcher.dispatch(this);
	}


	public void again() {
		dispatcher.dispatch(new Task<C>(period) {
			@Override
			public void run() {
				PeriodicTask.this.run();
			}
		});
	}

}
