package com.framsticks.util.dispatching;

public abstract class WrappedFuture<T> extends Future<T> {

	public abstract T process(T result);

	protected Future<T> future;

	public WrappedFuture(Future<T> future) {
		super(future);
		this.future = future;
	}

	@Override
	protected void result(T result) {
		T processed;
		processed = process(result);
		if (future != null) {
			future.pass(processed);
		}
	}

	public Future<T> move() {
		assert future != null;
		Future<T> result = future;
		future = null;
		return result;
	}

}
